static const QCC_opcode_t pr_opcodes[] = {
{.name="<DONE>",.opname="DONE",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_void,.type_b=&type_void,.type_c=&type_void}, //OP_DONE
{.name="*",.opname="MUL_F",.priority=3,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_MUL_F
{.name="*",.opname="MUL_V",.priority=3,.associative=ASSOC_LEFT,.type_a=&type_vector,.type_b=&type_vector,.type_c=&type_float}, //OP_MUL_V
{.name="*",.opname="MUL_FV",.priority=3,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_vector,.type_c=&type_vector}, //OP_MUL_FV
{.name="*",.opname="MUL_VF",.priority=3,.associative=ASSOC_LEFT,.type_a=&type_vector,.type_b=&type_float,.type_c=&type_vector}, //OP_MUL_VF
{.name="/",.opname="DIV_F",.priority=3,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_DIV_F
{.name="+",.opname="ADD_F",.priority=4,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_ADD_F
{.name="+",.opname="ADD_V",.priority=4,.associative=ASSOC_LEFT,.type_a=&type_vector,.type_b=&type_vector,.type_c=&type_vector}, //OP_ADD_V
{.name="-",.opname="SUB_F",.priority=4,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_SUB_F
{.name="-",.opname="SUB_V",.priority=4,.associative=ASSOC_LEFT,.type_a=&type_vector,.type_b=&type_vector,.type_c=&type_vector}, //OP_SUB_V
{.name="==",.opname="EQ_F",.priority=7,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_EQ_F
{.name="==",.opname="EQ_V",.priority=7,.associative=ASSOC_LEFT,.type_a=&type_vector,.type_b=&type_vector,.type_c=&type_float}, //OP_EQ_V
{.name="==",.opname="EQ_S",.priority=7,.associative=ASSOC_LEFT,.type_a=&type_string,.type_b=&type_string,.type_c=&type_float}, //OP_EQ_S
{.name="==",.opname="EQ_E",.priority=7,.associative=ASSOC_LEFT,.type_a=&type_entity,.type_b=&type_entity,.type_c=&type_float}, //OP_EQ_E
{.name="==",.opname="EQ_FNC",.priority=7,.associative=ASSOC_LEFT,.type_a=&type_function,.type_b=&type_function,.type_c=&type_float}, //OP_EQ_FNC
{.name="!=",.opname="NE_F",.priority=7,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_NE_F
{.name="!=",.opname="NE_V",.priority=7,.associative=ASSOC_LEFT,.type_a=&type_vector,.type_b=&type_vector,.type_c=&type_float}, //OP_NE_V
{.name="!=",.opname="NE_S",.priority=7,.associative=ASSOC_LEFT,.type_a=&type_string,.type_b=&type_string,.type_c=&type_float}, //OP_NE_S
{.name="!=",.opname="NE_E",.priority=7,.associative=ASSOC_LEFT,.type_a=&type_entity,.type_b=&type_entity,.type_c=&type_float}, //OP_NE_E
{.name="!=",.opname="NE_FNC",.priority=7,.associative=ASSOC_LEFT,.type_a=&type_function,.type_b=&type_function,.type_c=&type_float}, //OP_NE_FNC
{.name="<=",.opname="LE",.priority=6,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_LE_F
{.name=">=",.opname="GE",.priority=6,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_GE_F
{.name="<",.opname="LT",.priority=6,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_LT_F
{.name=">",.opname="GT",.priority=6,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_GT_F
{.name=".",.opname="INDIRECT_F",.priority=1,.associative=ASSOC_LEFT,.type_a=&type_entity,.type_b=&type_field,.type_c=&type_float}, //OP_LOAD_F
{.name=".",.opname="INDIRECT_V",.priority=1,.associative=ASSOC_LEFT,.type_a=&type_entity,.type_b=&type_field,.type_c=&type_vector}, //OP_LOAD_V
{.name=".",.opname="INDIRECT_S",.priority=1,.associative=ASSOC_LEFT,.type_a=&type_entity,.type_b=&type_field,.type_c=&type_string}, //OP_LOAD_S
{.name=".",.opname="INDIRECT_E",.priority=1,.associative=ASSOC_LEFT,.type_a=&type_entity,.type_b=&type_field,.type_c=&type_entity}, //OP_LOAD_ENT
{.name=".",.opname="INDIRECT_FI",.priority=1,.associative=ASSOC_LEFT,.type_a=&type_entity,.type_b=&type_field,.type_c=&type_field}, //OP_LOAD_FLD
{.name=".",.opname="INDIRECT_FU",.priority=1,.associative=ASSOC_LEFT,.type_a=&type_entity,.type_b=&type_field,.type_c=&type_function}, //OP_LOAD_FNC
{.name=".",.opname="ADDRESS",.priority=1,.associative=ASSOC_LEFT,.type_a=&type_entity,.type_b=&type_field,.type_c=&type_pointer}, //OP_ADDRESS
{.name="=",.opname="STORE_F",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_STORE_F
{.name="=",.opname="STORE_V",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_vector,.type_b=&type_vector,.type_c=&type_vector}, //OP_STORE_V
{.name="=",.opname="STORE_S",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_string,.type_b=&type_string,.type_c=&type_string}, //OP_STORE_S
{.name="=",.opname="STORE_ENT",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_entity,.type_b=&type_entity,.type_c=&type_entity}, //OP_STORE_ENT
{.name="=",.opname="STORE_FLD",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_field,.type_b=&type_field,.type_c=&type_field}, //OP_STORE_FLD
{.name="=",.opname="STORE_FNC",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_function,.type_b=&type_function,.type_c=&type_function}, //OP_STORE_FNC
{.name="=",.opname="STOREP_F",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_float}, //OP_STOREP_F
{.name="=",.opname="STOREP_V",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_pointer,.type_b=&type_vector,.type_c=&type_vector}, //OP_STOREP_V
{.name="=",.opname="STOREP_S",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_pointer,.type_b=&type_string,.type_c=&type_string}, //OP_STOREP_S
{.name="=",.opname="STOREP_ENT",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_pointer,.type_b=&type_entity,.type_c=&type_entity}, //OP_STOREP_ENT
{.name="=",.opname="STOREP_FLD",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_pointer,.type_b=&type_field,.type_c=&type_field}, //OP_STOREP_FLD
{.name="=",.opname="STOREP_FNC",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_pointer,.type_b=&type_function,.type_c=&type_function}, //OP_STOREP_FNC
{.name="<RETURN>",.opname="RETURN",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_void,.type_c=&type_void}, //OP_RETURN
{.name="!",.opname="NOT_F",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_void,.type_c=&type_float}, //OP_NOT_F
{.name="!",.opname="NOT_V",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_vector,.type_b=&type_void,.type_c=&type_float}, //OP_NOT_V
{.name="!",.opname="NOT_S",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_vector,.type_b=&type_void,.type_c=&type_float}, //OP_NOT_S
{.name="!",.opname="NOT_ENT",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_entity,.type_b=&type_void,.type_c=&type_float}, //OP_NOT_ENT
{.name="!",.opname="NOT_FNC",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_function,.type_b=&type_void,.type_c=&type_float}, //OP_NOT_FNC
{.name="<IF>",.opname="IF",.priority=-1,.associative=ASSOC_RIGHT,.type_a=&type_float,.type_b=NULL,.type_c=&type_void}, //OP_IF_I
{.name="<IFNOT>",.opname="IFNOT",.priority=-1,.associative=ASSOC_RIGHT,.type_a=&type_float,.type_b=NULL,.type_c=&type_void}, //OP_IFNOT_I
{.name="<CALL0>",.opname="CALL0",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_function,.type_b=&type_void,.type_c=&type_void}, //OP_CALL0
{.name="<CALL1>",.opname="CALL1",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_function,.type_b=&type_void,.type_c=&type_void}, //OP_CALL1
{.name="<CALL2>",.opname="CALL2",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_function,.type_b=&type_void,.type_c=&type_void}, //OP_CALL2
{.name="<CALL3>",.opname="CALL3",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_function,.type_b=&type_void,.type_c=&type_void}, //OP_CALL3
{.name="<CALL4>",.opname="CALL4",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_function,.type_b=&type_void,.type_c=&type_void}, //OP_CALL4
{.name="<CALL5>",.opname="CALL5",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_function,.type_b=&type_void,.type_c=&type_void}, //OP_CALL5
{.name="<CALL6>",.opname="CALL6",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_function,.type_b=&type_void,.type_c=&type_void}, //OP_CALL6
{.name="<CALL7>",.opname="CALL7",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_function,.type_b=&type_void,.type_c=&type_void}, //OP_CALL7
{.name="<CALL8>",.opname="CALL8",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_function,.type_b=&type_void,.type_c=&type_void}, //OP_CALL8
{.name="<STATE>",.opname="STATE",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_void}, //OP_STATE
{.name="<GOTO>",.opname="GOTO",.priority=-1,.associative=ASSOC_RIGHT,.type_a=NULL,.type_b=&type_void,.type_c=&type_void}, //OP_GOTO
{.name="&&",.opname="AND",.priority=10,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_AND_F
{.name="||",.opname="OR",.priority=11,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_OR_F
{.name="&",.opname="BITAND",.priority=8,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_BITAND_F
{.name="|",.opname="BITOR",.priority=9,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_BITOR_F
{.name="<FETCH_GBL_F>",.opname="FETCH_GBL_F",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_FETCH_GBL_F
{.name="<FETCH_GBL_V>",.opname="FETCH_GBL_V",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_vector,.type_b=&type_float,.type_c=&type_vector}, //OP_FETCH_GBL_V
{.name="<FETCH_GBL_S>",.opname="FETCH_GBL_S",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_string,.type_b=&type_float,.type_c=&type_string}, //OP_FETCH_GBL_S
{.name="<FETCH_GBL_E>",.opname="FETCH_GBL_E",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_entity,.type_b=&type_float,.type_c=&type_entity}, //OP_FETCH_GBL_E
{.name="<FETCH_GBL_FNC>",.opname="FETCH_GBL_FNC",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_function,.type_b=&type_float,.type_c=&type_function}, //OP_FETCH_GBL_FNC
{.name="<CIF>",.opname="C_ITOF",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_void,.type_c=&type_float}, //OP_CONV_ITOF
{.name="<CFI>",.opname="C_FTOI",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_void,.type_c=&type_integer}, //OP_CONV_FTOI
{.name="<CPIF>",.opname="CP_ITOF",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_float}, //OP_CP_ITOF
{.name="<CPFI>",.opname="CP_FTOI",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_integer}, //OP_CP_FTOI
{.name=".",.opname="INDIRECT",.priority=1,.associative=ASSOC_LEFT,.type_a=&type_entity,.type_b=&type_field,.type_c=&type_integer}, //OP_LOAD_I
{.name="=",.opname="STOREP_I",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_integer}, //OP_STOREP_I
{.name="=",.opname="STOREP_IF",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_integer}, //OP_STOREP_IF
{.name="=",.opname="STOREP_FI",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_float}, //OP_STOREP_FI
{.name="<=",.opname="LE_I",.priority=6,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_LE_I
{.name=">=",.opname="GE_I",.priority=6,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_GE_I
{.name="<",.opname="LT_I",.priority=6,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_LT_I
{.name=">",.opname="GT_I",.priority=6,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_GT_I
{.name="==",.opname="EQ_I",.priority=7,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_EQ_I
{.name="==",.opname="EQ_IF",.priority=7,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_float,.type_c=&type_integer}, //OP_EQ_IF
{.name="==",.opname="EQ_FI",.priority=7,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_integer,.type_c=&type_float}, //OP_EQ_FI
{.name="!=",.opname="NE_I",.priority=7,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_NE_I
{.name="|=",.opname="BITSET_F",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_BITSET
{.name="&~=",.opname="BITCLR_F",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_BITCLR
{.name="<>",.opname="BOUNDCHECK",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=NULL,.type_c=NULL}, //OP_BOUNDCHECK
{.name="=",.opname="STORE_I",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_STORE_I
{.name="=",.opname="STORE_IF",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_float,.type_b=&type_integer,.type_c=&type_integer}, //OP_STORE_IF
{.name="=",.opname="STORE_FI",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_integer,.type_b=&type_float,.type_c=&type_float}, //OP_STORE_FI
{.name="+",.opname="ADD_I",.priority=4,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_ADD_I
{.name="+",.opname="ADD_FI",.priority=4,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_integer,.type_c=&type_float}, //OP_ADD_FI
{.name="+",.opname="ADD_IF",.priority=4,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_float,.type_c=&type_float}, //OP_ADD_IF
{.name="-",.opname="SUB_I",.priority=4,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_SUB_I
{.name="-",.opname="SUB_FI",.priority=4,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_integer,.type_c=&type_float}, //OP_SUB_FI
{.name="-",.opname="SUB_IF",.priority=4,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_float,.type_c=&type_float}, //OP_SUB_IF
{.name="&",.opname="BITAND_I",.priority=8,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_BITAND_I
{.name="|",.opname="BITOR_I",.priority=9,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_BITOR_I
{.name="*",.opname="MUL_I",.priority=3,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_MUL_I
{.name="/",.opname="DIV_I",.priority=3,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_DIV_I
{.name="<IFNOTS>",.opname="IFNOTS",.priority=-1,.associative=ASSOC_RIGHT,.type_a=&type_string,.type_b=NULL,.type_c=&type_void}, //OP_IFNOT_S
{.name="<IFS>",.opname="IFS",.priority=-1,.associative=ASSOC_RIGHT,.type_a=&type_string,.type_b=NULL,.type_c=&type_void}, //OP_IF_S
{.name="^",.opname="XOR_I",.priority=9,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_XOR_I
{.name=">>",.opname="RSHIFT_I",.priority=5,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_RSHIFT_I
{.name="<<",.opname="LSHIFT_I",.priority=5,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_LSHIFT_I
{.name="<IF_F>",.opname="IF_F",.priority=-1,.associative=ASSOC_RIGHT,.type_a=&type_float,.type_b=NULL,.type_c=&type_void}, //OP_IF_F
{.name="<IFNOT_F>",.opname="IFNOT_F",.priority=-1,.associative=ASSOC_RIGHT,.type_a=&type_float,.type_b=NULL,.type_c=&type_void}, //OP_IFNOT_F
{.name="=",.opname="LOADA_F",.priority=13,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_integer,.type_c=&type_float}, //OP_LOADA_F
{.name="=",.opname="LOADA_V",.priority=13,.associative=ASSOC_LEFT,.type_a=&type_vector,.type_b=&type_integer,.type_c=&type_vector}, //OP_LOADA_V
{.name="=",.opname="LOADA_S",.priority=13,.associative=ASSOC_LEFT,.type_a=&type_string,.type_b=&type_integer,.type_c=&type_string}, //OP_LOADA_S
{.name="=",.opname="LOADA_ENT",.priority=13,.associative=ASSOC_LEFT,.type_a=&type_entity,.type_b=&type_integer,.type_c=&type_entity}, //OP_LOADA_ENT
{.name="=",.opname="LOADA_FLD",.priority=13,.associative=ASSOC_LEFT,.type_a=&type_field,.type_b=&type_integer,.type_c=&type_field}, //OP_LOADA_FLD
{.name="=",.opname="LOADA_FNC",.priority=13,.associative=ASSOC_LEFT,.type_a=&type_function,.type_b=&type_integer,.type_c=&type_function}, //OP_LOADA_FNC
{.name="=",.opname="LOADA_I",.priority=13,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_LOADA_I
{.name="<ARRAY>",.opname="GET_POINTER",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_integer,.type_c=&type_pointer}, //OP_GLOBALADDRESS
{.name="<ARRAY>",.opname="MUL4ADD_I",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_pointer}, //OP_POINTER_ADD
{.name="=",.opname="STORE_P",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_pointer,.type_b=&type_pointer,.type_c=&type_void}, //OP_STORE_P
{.name="=",.opname="LOADP_F",.priority=13,.associative=ASSOC_LEFT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_float}, //OP_LOADP_F
{.name="=",.opname="LOADP_V",.priority=13,.associative=ASSOC_LEFT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_vector}, //OP_LOADP_V
{.name="=",.opname="LOADP_S",.priority=13,.associative=ASSOC_LEFT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_string}, //OP_LOADP_S
{.name="=",.opname="LOADP_ENT",.priority=13,.associative=ASSOC_LEFT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_entity}, //OP_LOADP_ENT
{.name="=",.opname="LOADP_FLD",.priority=13,.associative=ASSOC_LEFT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_field}, //OP_LOADP_FLD
{.name="=",.opname="LOADP_FNC",.priority=13,.associative=ASSOC_LEFT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_function}, //OP_LOADP_FNC
{.name="=",.opname="LOADP_I",.priority=13,.associative=ASSOC_LEFT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_integer}, //OP_LOADP_I
{.name="+",.opname="ADD_SF",.priority=4,.associative=ASSOC_LEFT,.type_a=&type_string,.type_b=&type_float,.type_c=&type_string}, //OP_ADD_SF
{.name="-",.opname="SUB_S",.priority=4,.associative=ASSOC_LEFT,.type_a=&type_string,.type_b=&type_string,.type_c=&type_float}, //OP_SUB_S
{.name="<STOREP_C>",.opname="STOREP_C",.priority=1,.associative=ASSOC_RIGHT,.type_a=&type_float,.type_b=&type_string,.type_c=&type_void}, //OP_STOREP_C
{.name="<LOADP_C>",.opname="LOADP_C",.priority=1,.associative=ASSOC_LEFT,.type_a=&type_string,.type_b=&type_float,.type_c=&type_float}, //OP_LOADP_C
{.name="&",.opname="BITAND_IF",.priority=8,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_float,.type_c=&type_integer}, //OP_BITAND_IF
{.name="|",.opname="BITOR_IF",.priority=9,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_float,.type_c=&type_integer}, //OP_BITOR_IF
{.name="&",.opname="BITAND_FI",.priority=8,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_integer,.type_c=&type_float}, //OP_BITAND_FI
{.name="|",.opname="BITOR_FI",.priority=9,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_integer,.type_c=&type_float}, //OP_BITOR_FI
{.name="|=",.opname="BITSETP_F",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_float}, //OP_BITSETP
{.name="&~=",.opname="BITCLRP_F",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_float}, //OP_BITCLRP
{.name="*=",.opname="MULSTORE_F",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_MULSTORE_F
{.name="*=",.opname="MULSTORE_V",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_vector,.type_b=&type_float,.type_c=&type_vector}, //OP_MULSTORE_V
{.name="*=",.opname="MULSTOREP_F",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_float}, //OP_MULSTOREP_F
{.name="*=",.opname="MULSTOREP_V",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_vector}, //OP_MULSTOREP_V
{.name="/=",.opname="DIVSTORE_F",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_DIVSTORE_F
{.name="/=",.opname="DIVSTOREP_F",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_float}, //OP_DIVSTOREP_F
{.name="+=",.opname="ADDSTORE_F",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_ADDSTORE_F
{.name="+=",.opname="ADDSTORE_V",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_vector,.type_b=&type_vector,.type_c=&type_vector}, //OP_ADDSTORE_V
{.name="+=",.opname="ADDSTOREP_F",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_float}, //OP_ADDSTOREP_F
{.name="+=",.opname="ADDSTOREP_V",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_vector,.type_c=&type_vector}, //OP_ADDSTOREP_V
{.name="-=",.opname="SUBSTORE_F",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_SUBSTORE_F
{.name="-=",.opname="SUBSTORE_V",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_vector,.type_b=&type_vector,.type_c=&type_vector}, //OP_SUBSTORE_V
{.name="-=",.opname="SUBSTOREP_F",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_float}, //OP_SUBSTOREP_F
{.name="-=",.opname="SUBSTOREP_V",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_vector,.type_c=&type_vector}, //OP_SUBSTOREP_V
{.name="<=",.opname="LE_IF",.priority=6,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_float,.type_c=&type_integer}, //OP_LE_IF
{.name=">=",.opname="GE_IF",.priority=6,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_float,.type_c=&type_integer}, //OP_GE_IF
{.name="<",.opname="LT_IF",.priority=6,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_float,.type_c=&type_integer}, //OP_LT_IF
{.name=">",.opname="GT_IF",.priority=6,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_float,.type_c=&type_integer}, //OP_GT_IF
{.name="<=",.opname="LE_FI",.priority=6,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_integer,.type_c=&type_integer}, //OP_LE_FI
{.name=">=",.opname="GE_FI",.priority=6,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_integer,.type_c=&type_integer}, //OP_GE_FI
{.name="<",.opname="LT_FI",.priority=6,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_integer,.type_c=&type_integer}, //OP_LT_FI
{.name=">",.opname="GT_FI",.priority=6,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_integer,.type_c=&type_integer}, //OP_GT_FI
{.name="*",.opname="MUL_IF",.priority=3,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_float,.type_c=&type_integer}, //OP_MUL_IF
{.name="*",.opname="MUL_FI",.priority=3,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_integer,.type_c=&type_float}, //OP_MUL_FI
{.name="*",.opname="MUL_VI",.priority=3,.associative=ASSOC_LEFT,.type_a=&type_vector,.type_b=&type_integer,.type_c=&type_vector}, //OP_MUL_VI
{.name="*",.opname="MUL_IV",.priority=3,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_vector,.type_c=&type_vector}, //OP_MUL_IV
{.name="/",.opname="DIV_IF",.priority=3,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_float,.type_c=&type_integer}, //OP_DIV_IF
{.name="/",.opname="DIV_FI",.priority=3,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_integer,.type_c=&type_float}, //OP_DIV_FI
{.name="&&",.opname="AND_I",.priority=10,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_AND_I
{.name="||",.opname="OR_I",.priority=11,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_OR_I
{.name="&&",.opname="AND_IF",.priority=10,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_float,.type_c=&type_integer}, //OP_AND_IF
{.name="||",.opname="OR_IF",.priority=11,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_float,.type_c=&type_integer}, //OP_OR_IF
{.name="&&",.opname="AND_FI",.priority=10,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_integer,.type_c=&type_integer}, //OP_AND_FI
{.name="||",.opname="OR_FI",.priority=11,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_integer,.type_c=&type_integer}, //OP_OR_FI
{.name="!=",.opname="NE_IF",.priority=7,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_float,.type_c=&type_integer}, //OP_NE_IF
{.name="!=",.opname="NE_FI",.priority=7,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_integer}, //OP_NE_FI
{.name="<CONV_FTOS>",.opname="C_FTOS",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_void,.type_c=&type_string}, //OP_CONV_FTOS
{.name="<CONV_ITOS>",.opname="C_ITOS",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_integer,.type_b=&type_void,.type_c=&type_string}, //OP_CONV_ITOS
{.name="<CONV_VTOS>",.opname="C_VTOS",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_vector,.type_b=&type_void,.type_c=&type_string}, //OP_CONV_VTOS
{.name="<CONV_ETOS>",.opname="C_ETOS",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_entity,.type_b=&type_void,.type_c=&type_string}, //OP_CONV_ETOS
{.name="<>",.opname="OP_EMULATED",.priority=-1,.associative=ASSOC_LEFT,.type_a=&type_float,.type_b=&type_float,.type_c=&type_float}, //OP_NUMREALOPS
{.name="|=",.opname="BITSET_I",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_BITSET_I
{.name="|=",.opname="BITSETP_I",.priority=13,.associative=ASSOC_RIGHT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_integer}, //OP_BITSETP_I
{.name="*=",.opname="MULSTORE_I",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_MULSTORE_I
{.name="/=",.opname="DIVSTORE_I",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_DIVSTORE_I
{.name="+=",.opname="ADDSTORE_I",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_ADDSTORE_I
{.name="-=",.opname="SUBSTORE_I",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_integer,.type_b=&type_integer,.type_c=&type_integer}, //OP_SUBSTORE_I
{.name="*=",.opname="MULSTOREP_I",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_integer}, //OP_MULSTOREP_I
{.name="/=",.opname="DIVSTOREP_I",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_integer}, //OP_DIVSTOREP_I
{.name="+=",.opname="ADDSTOREP_I",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_integer}, //OP_ADDSTOREP_I
{.name="-=",.opname="SUBSTOREP_I",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_integer}, //OP_SUBSTOREP_I
{.name="*=",.opname="OP_MULSTORE_IF",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_integer}, //OP_MULSTORE_IF
{.name="*=",.opname="OP_MULSTOREP_IF",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_integer}, //OP_MULSTOREP_IF
{.name="/=",.opname="OP_DIVSTORE_IF",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_integer}, //OP_DIVSTORE_IF
{.name="/=",.opname="OP_DIVSTOREP_IF",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_integer}, //OP_DIVSTOREP_IF
{.name="+=",.opname="OP_ADDSTORE_IF",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_integer}, //OP_ADDSTORE_IF
{.name="+=",.opname="OP_ADDSTOREP_IF",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_integer}, //OP_ADDSTOREP_IF
{.name="-=",.opname="OP_SUBSTORE_IF",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_integer}, //OP_SUBSTORE_IF
{.name="-=",.opname="OP_SUBSTOREP_IF",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_float,.type_c=&type_integer}, //OP_SUBSTOREP_IF
{.name="*=",.opname="OP_MULSTORE_FI",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_float}, //OP_MULSTORE_FI
{.name="*=",.opname="OP_MULSTOREP_FI",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_float}, //OP_MULSTOREP_FI
{.name="/=",.opname="OP_DIVSTORE_FI",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_float}, //OP_DIVSTORE_FI
{.name="/=",.opname="OP_DIVSTOREP_FI",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_float}, //OP_DIVSTOREP_FI
{.name="+=",.opname="OP_ADDSTORE_FI",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_float}, //OP_ADDSTORE_FI
{.name="+=",.opname="OP_ADDSTOREP_FI",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_float}, //OP_ADDSTOREP_FI
{.name="-=",.opname="OP_SUBSTORE_FI",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_float}, //OP_SUBSTORE_FI
{.name="-=",.opname="OP_SUBSTOREP_FI",.priority=13,.associative=ASSOC_RIGHT_RESULT,.type_a=&type_pointer,.type_b=&type_integer,.type_c=&type_float}, //OP_SUBSTOREP_FI
{0}
};

enum {
  TOP_PRIORITY    = 13,
  FUNC_PRIORITY   = 1,
  UNARY_PRIORITY  = 2,
  ASSIGN_PRIORITY = 13,
  TERN_PRIORITY   = 12, // '?:'
};

static inline qccbool is_conditional_priority (int prio) { return (prio == 10 || prio == 11); }
